routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\WarehouseController;
use App\Http\Controllers\SalesPointController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\StockController;
use App\Http\Controllers\SalesPointStockController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {return view('dashboard');})->middleware(['auth'])->name('dashboard');


Route::group(['middleware' => 'auth'], function() {

    //warehousse route
    Route::get('warehouses/archiver/{id}',[WarehouseController::class,'archiver'])->name('warehouses.archiver');
   
   //salespoint route
   Route::get('salespoint/archiver/{id}',[SalesPointController::class,'archiver'])->name('salespoint.archiver');
   
   Route::get('salespoint/newslot',[SalesPointController::class,'newslot'])->name('salespoint.newslot');
   Route::post('stocks/newslotsave',[SalesPointController::class,'newslotsave'])->name('salespoint.newslotsave');
    
   
   //product route
   Route::get('product/archiver/{id}',[ProductController::class,'archiver'])->name('product.archiver');
   
   //clients route
   Route::get('client/archiver/{id}',[ClientController::class,'archiver'])->name('client.archiver');
    //stock transfer to warehouse route
   Route::get('stocks/transfer/{id}',[StockController::class,'transfer'])->name('stocks.transfer');
   Route::post('stocks/saveTransfer',[StockController::class,'saveTransfer'])->name('stocks.saveTransfer');
   //stock transfer to salespoint route
    Route::get('stocks/transferSales/{id}',[SalesPointStockController::class,'transferSales'])->name('stocks.transferSalespoint');
    Route::post('stocks/saveTransferSales',[SalesPointStockController::class,'saveTransferSales'])->name('stocks.saveTransferSales');
    
   Route::resource('warehouses', WarehouseController::class);

    // sales point route
    Route::resource('salespoint', SalesPointController::class);


    // product route
    Route::resource('product', ProductController::class);
    // client route
    Route::resource('client', ClientController::class);

    // stock route stocks.getSlots
    Route::post('stocks/getSlots',[StockController::class,'getSlots'])->name('stocks.getSlots');
    Route::resource('stocks', StockController::class);
});

require __DIR__.'/auth.php';

app/Models/Stock.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Stock extends Model
{
    use HasFactory;

    public function warehouse()
    {
        return $this->belongsTo(Warehouse::class);
    }

    public function product()
    {
        return $this->belongsTo(Product::class);
    }

}

app/Http/Controllers/StockController.php
<?php

namespace App\Http\Controllers;

use App\Models\Lot;
use Illuminate\Http\Request;
use App\Models\Warehouse;
use App\Models\Product;
use App\Models\SalesPoint;
use App\Models\Stock;

class StockController extends Controller
{
    public function index()
    {

        $stocks = Stock::all();

       return view('stock.index', ['stocks' => $stocks]);
    }
    public function create()
    {
        $products =Product::where('stat',1)->get();
        $warehouses =Warehouse::where('stat',1)->get();
        return view('stock.create',['warehouses'=> $warehouses , 'products'=>$products]);
    }
    public function store(Request $req )
    {
        //dd($req->all());

        $req->validate([
            'warehouse_id' => 'required',
            'product_id' => 'required',
            'quantity' => 'required',
          ]);
          $add_to_stock = false;
          $coffee = Stock::find($req->id);
          
          if(!$coffee){
            $coffee = Stock::where('warehouse_id',$req->warehouse_id)->where('product_id',$req->product_id)
            ->first();
            $add_to_stock = true;
            if(!$coffee){
                $coffee = new Stock;
              }
          }

        $coffee->warehouse_id=$req->warehouse_id;
        $coffee->product_id=$req->product_id;
        if(!$add_to_stock)
            $coffee->quantity=$req->quantity;
        else
            $coffee->quantity=$coffee->quantity+$req->quantity;

        $coffee->save();

        return redirect()->route('stocks.index');
    }

    public function edit($id)
    {
        $model = Stock::find($id);
        $products =Product::where('stat',1)->get();
        $warehouses =Warehouse::where('stat',1)->get();
        return view('stock.create',['warehouses'=> $warehouses ,
         'products'=>$products , 'model'=>$model]);
    }
    public function transfer($id)
    {//dd($id);

        $model = Stock::find($id);
        $warehouses = Warehouse::where('stat',1)->where('id','!=',$model->warehouse_id)->get();
        $salespoint = SalesPoint::where('stat',1)->where('id','!=',$model->warehouse_id)->get();

        return view('stock.transfer',['warehouses'=> $warehouses ,'salespoint'=>$salespoint, 'model'=>$model]);
    }

    public function saveTransfer(Request $req)
    {//dd($req->all());

        $model = Stock::find($req->id);
        $model->quantity = $model->quantity - $req->quantity;
        $model->save();

        $stock = Stock::where('product_id',$model->product_id)
        ->where('warehouse_id',$req->warehouse_dist_id)->first();
        if($stock){
            $stock->quantity = $stock->quantity + $req->quantity;
        }else{
            $stock = new Stock;
            $stock->quantity = $req->quantity;
            $stock->product_id = $model->product_id;
            $stock->warehouse_id = $req->warehouse_dist_id;
        }
        $stock->save();

        return redirect()->route('stocks.index');
    }
    //////
    public function transferSales($id)
    { //dd($id);

        $model = Stock::find($id);
        $warehouses = Warehouse::where('stat',1)->where('id','!=',$model->warehouse_id)->get();
        $salespoint = SalesPoint::where('stat',1)->where('id','!=',$model->warehouse_id)->get();
        
        return view('stock.transferSalespoint',['warehouses'=> $warehouses ,'salespoint'=>$salespoint,
         'model'=>$model]);
    }

    public function saveTransferSales(Request $req)
    {//dd($req->all());

        $model = Stock::find($req->id);
        $model->quantity = $model->quantity - $req->quantity;
        $model->save();

        $stock = Stock::where('product_id',$model->product_id)
        ->where('salespoint_id',$req->salespoint_dist_id)->first();
        if($stock){
            $stock->quantity = $stock->quantity + $req->quantity;
        }else{
            $stock = new Stock;
            $stock->quantity = $req->quantity;
            $stock->product_id = $model->product_id;
            $stock->salespoint_id = $req->salespoint_dist_id;
        }
        $stock->save();

        return redirect()->route('stocks.index');
    }
    public function getSlots(Request $req)
    {
        $slots = Lot::where('salespoint', $req->salespoint_dist)->get();
        $html = '';
        foreach($slots as $slot){
          $html .=  "<option value='".$slot->id."'>".$slot->name."</option>";
        }

        return response()->json(['html'=>$html]);
    }
    
}

resources/views/stock/create.blade.php
@extends('layouts.app')

@section('content')
<style>
   .view{
      width: 400px;
   }
</style>
<div class="view mt-4">
    <h1 class="mb-4">New Stock</h1>
    <form action="{{route('stocks.store')}}" method="post">
        @csrf
    <div class="form-group">
       <label for="warehouse_id" >Warehouse Name</label>
       <select name="warehouse_id" class="form-control" required>
         @foreach($warehouses as $wh)
         <option value="{{$wh->id}}" @if($wh->id == @$model->warehouse_id) selected @endif>{{$wh->name}}</option>
         @endforeach
       </select>
    </div>
    <div class="form-group">
      <label for="product_id" >Product Name</label>
      <select name="product_id" class="form-control" required>
        @foreach($products as $pr)
        <option value="{{$pr->id}}" @if($pr->id == @$model->product_id) selected @endif>{{$pr->name}}</option>
        @endforeach
      </select>
   </div>
    <div class="form-group mb-2">
       <label for="quantity">Quantity</label>
       <input required name="quantity" value="{{@$model->quantity}}"  class="form-control" type="number">
    </div>
    <input name="id" value="{{@$model->id}}"  type="hidden">
    <a href="{{route('stocks.index')}}" class="btn btn-secondary">Cancel</a>
    <button type="submit" class="btn btn-primary" style="background: blue">Save</button>
    </form>
   </div>
@endsection

resources/views/stock/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="mt-4">
    <a href="{{route('stocks.create')}}" class="btn btn-success">New Stock</a>
    <a href="{{route('stocks.create')}}" class="btn btn-warning disabled">Consume Stock</a>
    </div>
    <div class="mt-4">
        <table class="table  table-striped table-bordered" >
            <thead>
                <tr>
                    <th>Wharehouse Name</th>
                    <th>Product name</th>
                    <th>Quantity</th>
                    <th>Action</th>
                </tr>
            </thead>
            
            <tbody>
                @foreach ($stocks as $coffee)
                <tr>
                    <td>{{ $coffee->warehouse->name }}</td>
                    <td>{{$coffee->product->name}}</td>
                    <td>{{$coffee->quantity}}</td>
                    <td>
                        <a href=""  class="btn btn-secondary">Achive</a>
                        <a href="{{route('stocks.edit',$coffee->id)}}" class="btn btn-info">Edit</a>
                        <a href="{{route('stocks.transfer',$coffee->id)}}" class="btn btn-success">Tansfer to Warehouse</a>
                        <a href="{{route('stocks.transferSalespoint',$coffee->id)}}" class="btn btn-success">Tansfer to Salespoint</a>      
                    </td>
                </tr>
                @endforeach
            </tbody>
        </table>
    </div>

 
@endsection

resources/views/stock/transfer.blade.php
@extends('layouts.app')

@section('content')
<style>
   .view{
      width: 400px;
      
   }
</style>
<div class="view mt-4">
    <h1 class="mb-4">Transfer Stock</h1>
    <form action="{{route('stocks.saveTransfer')}}" method="post">
        @csrf
    <div class="form-group">
       <label for="warehouse_id" >From Warehouse</label>
       <input name="warehouse_id" class="form-control" required type="text" readonly 
       value="{{$model->warehouse->name}}">   
    </div>
    <div class="form-group">
      <label for="product_id" >Transfer the Product </label>
      <input name="product_id" class="form-control" required type="text" readonly 
       value="{{$model->product->name}}">
    </div>
      <div class="form-group">
         <label for="warehouse_dist_id" >To the Warehouse</label>
         <select name="warehouse_dist_id" class="form-control" required>
           @foreach($warehouses as $wh)
           <option value="{{$wh->id}}">{{$wh->name}}</option>
           @endforeach
         </select>
      </div>
      <div class="form-group mb-2">
         <label for="quantity">Quantity</label>
         <input required name="quantity" class="form-control" placeholder="{{$model->quantity}}" type="number"
         max="{{$model->quantity}}">
      </div>
      <input name="id" required type="hidden" value="{{$model->id}}">
    <a href="{{route('stocks.index')}}" class="btn btn-secondary">Cancel</a>
    <button type="submit" class="btn btn-primary" style="background: blue">Save</button>
    </form>
   </div>
@endsection

resources/views/stock/transferSalespoint.blade.php
@extends('layouts.app')

@section('content')
<style>
   .view{
      width: 400px;
      
   }
</style>
<div class="view mt-4">
    <h1 class="mb-4">Transfer Stock</h1>
    <form action="{{route('stocks.saveTransferSales')}}" method="post">
        @csrf
    <div class="form-group">
       <label for="warehouse_id" >From Warehouse</label>
       <input name="warehouse_id" class="form-control" required type="text" readonly 
       value="{{$model->warehouse->name}}">   
    </div>
    <div class="form-group">
      <label for="product_id" >Transfer the Product </label>
      <input name="product_id" class="form-control" required type="text" readonly 
       value="{{$model->product->name}}">
    </div>
      <div class="form-group">
         <label for="salespoint_dist_id" >To the Salespoint</label>
         <select name="salespoint_dist_id" id="salespoint_dist_id" class="form-control" required>
            <option  readonly>Selectionnez une machine</option>
           @foreach($salespoint as $sa)
           <option value="{{$sa->id}}">{{$sa->name}}</option>
           @endforeach
         </select>
      </div>
       <div class="form-group">
         <label for="slot_dist_id" >To the Slot</label>
         <select name="slot_dist_id" id="slot_dist_id" class="form-control" required>
           {{-- @foreach($lots as $sl)
           <option value="{{$sl->id}}">{{$sl->name}}</option>
           @endforeach --}}

         </select>
      </div> 
      <div class="form-group mb-2">
         <label for="quantity">Quantity</label>
         <input required name="quantity" class="form-control" placeholder="{{$model->quantity}}" type="number"
         max="{{$model->quantity}}">
      </div>
      <input name="id" required type="hidden" value="{{$model->id}}">
    <a href="{{route('stocks.index')}}" class="btn btn-secondary">Cancel</a>
    <button type="submit" class="btn btn-primary" style="background: blue">Save</button>
    </form>
   </div>
   @endsection
   @section('js')
   <script>
      $('#salespoint_dist_id').on('change',function () {
            console.log($('#salespoint_dist_id').val())
            $.ajaxSetup({
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                }
            });

            var formData = {
               salespoint_dist:$('#salespoint_dist_id').val()
            };

            $.ajax({
                type: "POST",
                url: '{{ route('stocks.getSlots') }}',
                data: formData,
                dataType: 'json',
                success: function (data) {
                    $('#slot_dist_id').html(data.html);
                      
                },
                error: function (data) {
                    console.log('Error:', data);
                }
            });

        });
   </script>
@endsection